#!/bin/bash                                                                     
#PLUGNAME=MPBureau #Not needed it looks, works fine without
PLUGIP6OUTLETS=192.168.9.240
PLUGIP3OUTLETS=192.168.9.241
PLUGUSER=ubnt			#default "ubnt"
PLUGPASSWORD=ubnt		#default "ubnt"
SESSIONID=01234567890123456789012345678901

DOMOTICZSERVER=192.168.9.238
DOMOTICZPORT=8080

#Create virtual sensors in Domoticz and enter their IDX's here. For the sensor types, see Domoticz JSON wiki
IDX_POWER_1=164
IDX_VOLT_1=158
IDX_CURRENT_1=170
IDX_PF_1=

IDX_POWER_2=165
IDX_VOLT_2=159
IDX_CURRENT_2=171
IDX_PF_2=

IDX_POWER_3=166
IDX_VOLT_3=160
IDX_CURRENT_3=172
IDX_PF_3=

IDX_POWER_4=167
IDX_VOLT_4=161
IDX_CURRENT_4=173
IDX_PF_4=

IDX_POWER_5=168
IDX_VOLT_5=162
IDX_CURRENT_5=174
IDX_PF_1=

IDX_POWER_6=169
IDX_VOLT_6=163
IDX_CURRENT_6=175
IDX_PF_6=

IDX_POWER_11=182
IDX_VOLT_11=179
IDX_CURRENT_11=185
IDX_PF_11=

IDX_POWER_12=183
IDX_VOLT_12=180
IDX_CURRENT_12=186
IDX_PF_12=

IDX_POWER_13=184
IDX_VOLT_13=181
IDX_CURRENT_13=187
IDX_PF_13=	

if ping -c 1 $PLUGIP6OUTLETS > /dev/null ; then  # if host is online then:
	
	#Login to webinterface of plug
	curl --silent -X POST -d "username=$PLUGUSER&password=$PLUGPASSWORD" -b "AIROS_SESSIONID=$SESSIONID" $PLUGIP6OUTLETS/login.cgi

	#Turn outlet no1 on
	#curl --silent -X PUT -d output=1 -b "AIROS_SESSIONID="$SESSIONID 192.168.4.22/sensors/1 > /dev/null
	
	#Retrieve all data from JSON-output
	SENSOR=$(curl --silent -b "AIROS_SESSIONID=$SESSIONID" $PLUGIP6OUTLETS/sensors) 

	for i in 1 2 3 4 5 6
		do
			#compute offset between lines
			line=$(((i-1)*9))
			Current=$((line+5))
			Volt=$((line+6))
			Power=$((line+3))
			PowerFactor=$((line+7))
			VoltPosition="f"$Volt
			CurrentPosition="f"$Current
			PowerPosition="f"$Power
			PowerFactorPosition="f"$PowerFactor
			MPVOLTAGE=$(echo $SENSOR | cut -d "," -$VoltPosition | cut -d ":" -f2  | awk '{printf("%.3f\n", $1)}')
			MPCURRENT=$(echo $SENSOR | cut -d "," -$CurrentPosition | cut -d ":" -f2 | awk '{printf("%.2f\n", $1)}')
			MPPOWER=$(echo $SENSOR | cut -d "," -$PowerPosition | cut -d ":" -f2  | awk '{printf("%.1f\n", $1)}')
			#echo $MPVOLTAGE 'Volt-new'
			#echo $MPCURRENT 'Current-new'
			#echo $MPPOWER 'Power-new'
			#report Voltage
			eval IDX='$'IDX_VOLT_$i
			curl --silent $DOMOTICZSERVER:$DOMOTICZPORT'/json.htm?type=command&param=udevice&idx='$IDX'&svalue='$MPVOLTAGE > /dev/null
			#report Power
			eval IDX='$'IDX_POWER_$i
			curl --silent $DOMOTICZSERVER:$DOMOTICZPORT'/json.htm?type=command&param=udevice&idx='$IDX'&svalue='$MPPOWER > /dev/null 
			#report Current
			eval IDX='$'IDX_CURRENT_$i
			curl --silent $DOMOTICZSERVER:$DOMOTICZPORT'/json.htm?type=command&param=udevice&idx='$IDX'&svalue='$MPCURRENT > /dev/null 
		done


	#Grab powerfactor (cos phi) from retrieved values and leave 2 decimals, stripoff rest (change printf %.2f if you want more/less decimals)
	MPPOFA=$(echo $SENSOR | cut -d "," -f7 | cut -d ":" -f2 | awk '{printf("%.2f\n", $1)}')
	#Send data to Domoticz sensor without displaying any curl output on commandline
	#curl --silent $DOMOTICZSERVER:$DOMOTICZPORT'/json.htm?type=command&param=udevice&idx='$IDX_PF'&svalue='$MPPOFA > /dev/null 
	#Display mains voltage (Volt) on commandline
	#echo $MPPOFA 'cos phi'

	#Display info message
	#echo "Sensors in Domoticz should be updated with new values, have a look at them"
	
	#Turn outlet no1 off
	#curl --silent -X PUT -d output=0 -b "AIROS_SESSIONID="$SESSIONID 192.168.4.22/sensors/1 > /dev/null

	#Logout from plug
	curl -b "AIROS_SESSIONID=$SESSIONID" $PLUGIP6OUTLETS/logout.cgi


else #Plug not responding to ping, display error message
	echo "Plug not responding to ping, is it connected to your WLAN?"
fi

if ping -c 1 $PLUGIP3OUTLETS > /dev/null ; then  # if host is online then:
	
	#Login to webinterface of plug
	curl --silent -X POST -d "username=$PLUGUSER&password=$PLUGPASSWORD" -b "AIROS_SESSIONID=$SESSIONID" $PLUGIP3OUTLETS/login.cgi

	#Turn outlet no1 on
	#curl --silent -X PUT -d output=1 -b "AIROS_SESSIONID="$SESSIONID 192.168.4.22/sensors/1 > /dev/null
	
	#Retrieve all data from JSON-output
	SENSOR=$(curl --silent -b "AIROS_SESSIONID=$SESSIONID" $PLUGIP3OUTLETS/sensors) 

	for i in 11 12 13
		do
			#compute offset between lines
			line=$(((i-11)*9))
			Current=$((line+5))
			Volt=$((line+6))
			Power=$((line+3))
			PowerFactor=$((line+7))
			VoltPosition="f"$Volt
			CurrentPosition="f"$Current
			PowerPosition="f"$Power
			PowerFactorPosition="f"$PowerFactor
			MPVOLTAGE=$(echo $SENSOR | cut -d "," -$VoltPosition | cut -d ":" -f2  | awk '{printf("%.3f\n", $1)}')
			MPCURRENT=$(echo $SENSOR | cut -d "," -$CurrentPosition | cut -d ":" -f2 | awk '{printf("%.2f\n", $1)}')
			MPPOWER=$(echo $SENSOR | cut -d "," -$PowerPosition | cut -d ":" -f2  | awk '{printf("%.1f\n", $1)}')
			#echo $MPVOLTAGE 'Volt-new'
			#echo $MPCURRENT 'Current-new'
			#echo $MPPOWER 'Power-new'
			#report Voltage
			eval IDX='$'IDX_VOLT_$i
			curl --silent $DOMOTICZSERVER:$DOMOTICZPORT'/json.htm?type=command&param=udevice&idx='$IDX'&svalue='$MPVOLTAGE > /dev/null
			#report Power
			eval IDX='$'IDX_POWER_$i
			curl --silent $DOMOTICZSERVER:$DOMOTICZPORT'/json.htm?type=command&param=udevice&idx='$IDX'&svalue='$MPPOWER > /dev/null 
			#report Current
			eval IDX='$'IDX_CURRENT_$i
			curl --silent $DOMOTICZSERVER:$DOMOTICZPORT'/json.htm?type=command&param=udevice&idx='$IDX'&svalue='$MPCURRENT > /dev/null 
		done


	#Grab powerfactor (cos phi) from retrieved values and leave 2 decimals, stripoff rest (change printf %.2f if you want more/less decimals)
	MPPOFA=$(echo $SENSOR | cut -d "," -f7 | cut -d ":" -f2 | awk '{printf("%.2f\n", $1)}')
	#Send data to Domoticz sensor without displaying any curl output on commandline
	#curl --silent $DOMOTICZSERVER:$DOMOTICZPORT'/json.htm?type=command&param=udevice&idx='$IDX_PF'&svalue='$MPPOFA > /dev/null 
	#Display mains voltage (Volt) on commandline
	#echo $MPPOFA 'cos phi'

	#Display info message
	#echo "Sensors in Domoticz should be updated with new values, have a look at them"
	
	#Turn outlet no1 off
	#curl --silent -X PUT -d output=0 -b "AIROS_SESSIONID="$SESSIONID 192.168.4.22/sensors/1 > /dev/null

	#Logout from plug
	curl -b "AIROS_SESSIONID=$SESSIONID" $PLUGIP3OUTLETS/logout.cgi


else #Plug not responding to ping, display error message
	echo "Plug not responding to ping, is it connected to your WLAN?"
fi